****************************************
*	 Prozenummer = 1
*	 Delay = 500
*	 Eventsource = 0
*	 Number of Loops = 0
*	 Prioritt = 0
*	 Version = 1
****************************************
rem  Das Programm BAS_DMO6 ist ein digitaler PID-Regler. 
rem  Damit das Programm auch auf ADwin-2 und ADwin-4 Karten
rem  benutzt werden kann arbeitet der Regler nur mit 
rem  Integer-Variablen. Die Reglerkoeffizienten werden auf
rem  dem PC berechnet, mit 1000 multipliziert und als Integer-
rem  Parameter an die ADwin-Karte uebergeben.
rem  Par_1 = Sollwert in Digits
rem  Par_2 = q0 * 1000 = k *(1+t0/(2*ti)+td/t0) *1000
rem  Par_3 = q1 * 1000 = -k * (1+2*td/t0-t0/(2*ti)) * 1000
rem  Par_4 = q2 * 1000 = k * td/t0 *1000
rem  Par_5 = Bufferindex fuer dei Regelabweichung  

dim iw,abweichung as long
dim Sollwert, Verstrkung as long
dim ek, ek1, ek2, uk, uk1 as long
dim q0,q1,q2 as long
dim data[1][600] as short

init: 
sollwert = par_1
q0=par_2 
q1=par_3 
q2=par_4 
par_5 = 0
set_mux(0)

event:
set_mux(0)            'Multiplexer auf den Eingang setzen
uk1 = uk + q0*ek
start_conv(1)         'Messung starten
dac 1, (uk1/1000)     'Stellwert ausgeben
                      'Da alle Parameter mit 1000 multiplziert wurden,
                      'mu er durch 1000 dividiert werden
ek2=ek1
ek1=ek
uk = uk1+q1*ek1+q2*ek2
wait_eoc(1)           'Warten bis der ADC ausgelesen werden kanm
ek = sollwert - readadc(1)  'Auslesen und Regelabweichung berechnen
  
  rem Die Regelabweichung in einen Buffer schreiben
if (par_5<500) then
  data[1][par_5] = ek
  par_5=par_5+1
  if (par_5=500) then activate_pc
  endif

  rem Falls die Parameter geaendert wurden
  rem die muessen die neuen Parameter uebernommen werden.
if (par_9=1) then
  sollwert = par_1
  q0=par_2 
  q1=par_3 
  q2=par_4 
  par_9=0
  par_5=0
  endif




               