unit BAS_DMO3_;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, ExtCtrls, StdCtrls, OleCtrls, ChartFX;

type
  TForm1 = class(TForm)
    ButtonStart: TButton;
    Timer1: TTimer;
    ButtonExit: TButton;
    Edit1: TEdit;
    graph1: TChartFX;
    procedure Start_Click(Sender: TObject);
    procedure Timer1_Timer(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure ButtonExitClick(Sender: TObject);

  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

var
  Form1: TForm1;

implementation

uses uadwin;

{$R *.DFM}

const
   btlpath = 'c:\ADBASIC3\';      // path for btl-file
//   btlfile     = 'ADWIN4.BTL';  // btl-file depends on ADwin-System
//   btlfile     = 'ADWIN5.BTL';
//   btlfile     = 'ADWIN8.BTL';
   btlfile     = 'ADWIN9.BTL';
//   size        = 100000;          // size of memory depends on ADwin-System
   size        = 400000;
//   size        = 800000;
//   process = 'BAS_DMO3.T41';       // binary file depends on ADwin-System
//   process = 'BAS_DMO3.T51';
//   process = 'BAS_DMO3.T81';
   process = 'BAS_DMO3.T91';


procedure TForm1.Start_Click(Sender: TObject);
begin
  start(1);                  // start process
  Timer1.Enabled := TRUE     // start timer
end;

procedure TForm1.Timer1_Timer(Sender: TObject);
var
  index  : INTEGER;
  values : ARRAY[1..1000] of WORD;
begin
  if get_activate(1) = 1 then begin         // if the meassuremend is finished
    get_data(1, 1, 1000, @values[1]);    // get elements from tha ADbasic data_1
    graph1.OpenDataEx(1,1,1000);         // transfer data to the chart
    for index := 0 to 999 do
      graph1.Value[index] := values[index+1];
    graph1.CloseData(1);
    graph1.RGB2DBk := clWhite;
    Timer1.Enabled := False;             // stop timer
  end;
end;

procedure TForm1.FormCreate(Sender: TObject);
var directory : string;
begin
  graph1.PointType := 0;
  graph1.Decimals  := 0;
  Boot(btlpath+btlfile,size);             // boot ADwin-System
  directory:=extractfilepath(Paramstr(0)); // path of the program
  ADBload(directory+process);              // load process
end;

procedure TForm1.ButtonExitClick(Sender: TObject);
begin
  close;  // end program
end;

end.
