****************************************
*	 Prozenummer = 1
*	 Delay = 1000
*	 Eventsource = 0
*	 Number of Loops = 0
*	 Prioritt = 0
*	 Version = 1
*	 FastStop = 0
*	 AdbasicVersion = 2000000
****************************************
REM The program BAS_DMO2.BAS is a digital proportional controller. The 
REM setpoint is specified with PAR_1, the gain with PAR_2. This can run 
REM at up to 50kHz.

DIM deviation, act AS INTEGER

INIT:
  PAR_1 = 2048	'Specify initial setpoint

EVENT:
  REM Compute the control deviation from the
  REM difference between the specified setpoint PAR_1
  REM and the momentary voltage applied to Input 1.
  deviation = PAR_1 - ADC(1)

  REM Compute actuating value
  act = deviation * PAR_2 + 2048

  REM Output actuating value on Analog Output 1
  DAC(1, act)

               