/*************************************************************
* Include File zum Einbinden der Prototypen fr die Aufrufe an 
* die ADwin-Karten.
* Erstellt am : 06.03.1996 von Marcus Galemann
* gendert am :	22.08.1996 von Martin Hotze
**************************************************************/

#ifndef __adwin_h__
#define __adwin_h__

#ifdef _WIN32
#define	my_FAR
#else
#define my_FAR __far
#endif

#ifdef __cplusplus
extern "C" {
#endif  /* __cplusplus */



long  FAR PASCAL ADboot(char my_FAR *dateiname,short Linkaddresse,long iboardsize,short msgbox);
short FAR PASCAL ADBload(char my_FAR *dateiname,short Linkaddresse,short msgbox);

short FAR PASCAL ADTest_Version(short Linkaddresse,short msgbox);
short FAR PASCAL ADProzessorTyp(short Linkaddresse);
short FAR PASCAL AD_Auslastung (short Linkaddresse);
long  FAR PASCAL AD_Memory     (short Linkaddresse);

short FAR PASCAL Get_ADC    (short nadc, short nadr);
short FAR PASCAL Set_DAC    (short ndac, short iw, short nadr);
short FAR PASCAL Set_Digout (short iw, short nadr);
long  FAR PASCAL Get_Digout (short nadr);
long  FAR PASCAL Get_Digin  (short nadr);
short FAR PASCAL Set_DigoutX(short iw, short nadr);
long  FAR PASCAL Get_DigoutX(short nadr);
long  FAR PASCAL Get_DiginX (short nadr);

short FAR PASCAL ADB_Start  (short np, short nadr);
short FAR PASCAL ADB_Stop   (short np, short nadr);
short FAR PASCAL Start		(short np, short nadr);
short FAR PASCAL Stop		(short np, short nadr);
short FAR PASCAL Set_ADBPar (short np, long iw, short nadr);
short FAR PASCAL Set_ADBFPar(short np, float fw, short nadr);
long  FAR PASCAL Get_ADBPar (short np, short nadr);
float FAR PASCAL Get_ADBFPar(short np,short nadr);

short FAR PASCAL Get_List (void my_FAR *tarr,short typ, short nadc, short proc,long il, short nadr);
short FAR PASCAL Set_List (void my_FAR *tarr,short typ,short ndac, long il, short nadr );

long  FAR PASCAL Get_Data_Length(short nr,short nadr);
short FAR PASCAL Get_Data (void my_FAR *tarr,short typ, short nadc, long lstart, long il ,short nadr);
short FAR PASCAL Set_Data (void my_FAR *tarr,short typ, short nadc, long lstart,long il ,short nadr);

long  FAR PASCAL Get_Fifo_Count (short nadc, short nadr );
long  FAR PASCAL Get_Fifo_Empty (short nadc, short nadr );
short FAR PASCAL Clear_Fifo     (short nadc, short nadr );
short FAR PASCAL Get_Fifo (void my_FAR *tarr,short typ, short nadc, long il ,short nadr);
short FAR PASCAL Set_Fifo (void my_FAR *tarr,short typ, short nadc, long il ,short nadr);




// Prototypen von oft bentigten Me- und Steuerungsfunktionen aus der Datei adwin.c

short FAR PASCAL ADC(short nr);
short FAR PASCAL Auslast();
long  FAR PASCAL DigIn(); 
long  FAR PASCAL DigOut();
long  FAR PASCAL Freemem();
long  FAR PASCAL GetActivate(short nr);
short FAR PASCAL SetDigOut(short iw);
short FAR PASCAL SetDAC(short ndac, short iw);
short FAR PASCAL SetDACListe(short ndac, long il, short my_FAR *iw);
short FAR PASCAL SetPar(short npar, long iw);
short FAR PASCAL SetOpt(short npar, long iw);
short FAR PASCAL SetFPar(short npar, float fw);
short FAR PASCAL ADBStart(short nprz);
short FAR PASCAL ADBStop(short nprz);
short FAR PASCAL ZykStart(short nprz);
short FAR PASCAL ZykStop(short nprz);
long  FAR PASCAL GetPar(short nr);
long  FAR PASCAL GetOpt(short nr);
float FAR PASCAL GetFPar (short nr);
short FAR PASCAL ReadADListe (short nadc, long il, short my_FAR *iw);
short FAR PASCAL GetData (short ndata, long nstart, long il, short my_FAR *id);
short FAR PASCAL GetlData (short ndata, long start, long il, long my_FAR *id);
short FAR PASCAL GetfData (short ndata, long nstart, long il, float my_FAR *id);
short FAR PASCAL SetData (short ndata, long il, short my_FAR *id);
short FAR PASCAL SetlData (short ndata, long il, long my_FAR *id);
short FAR PASCAL SetfData (short ndata, long il, float my_FAR *id);
long  FAR PASCAL GetFifoCount (short nfifo);
long  FAR PASCAL GetFifoEmpty (short nfifo);
short FAR PASCAL ClearFifo (short nfifo);
short FAR PASCAL GetFifo (short nfifo, long il, short my_FAR *ifi);
short FAR PASCAL GetlFifo (short nfifo, long il, long my_FAR *ifi);
short FAR PASCAL GetfFifo (short nfifo, long il, float my_FAR *ifi);
short FAR PASCAL SetFifo (short nfifo, long il, short my_FAR *ifi);
short FAR PASCAL SetlFifo (short nfifo, long il, long my_FAR *ifi);
short FAR PASCAL SetfFifo (short nfifo, long il, float my_FAR *ifi);
short FAR PASCAL Test();
long  FAR PASCAL Iserv(char my_FAR *dateiname, long iboardsize);
short FAR PASCAL ADBPrLoad(char my_FAR *dateiname);
void  FAR PASCAL ErrMessage(short state);


#ifdef __cplusplus
}
#endif 	

#endif //__adwin_h__
