/*************************************************************
* Source File zum Einbinden der hufig benutzten Me- und 
* Steuerungsfunktionen fr die die ADwin-Karten. 
* Erstellt am : 22.08.1996 von Martin Hotze
* gendert am :	22.08.1996 von 
* gendert am :	01.04.1998 von HPB nderung:ADwin.c ->ADwin.cpp  #include "stdafx.h"
**************************************************************/

// #include "stdafx.h"	  // notwendig bei MFC Projekten
#include "windows.h"
#include "adwin.h"

#define linkaddr 0x150    // Linkadresse

short message=1;          // Fehlermeldung beim Fehlschlagen der Funktionen:
						  // Iserv, ADBPrLoad u. Test.	0 = Fehlermeldung nicht ausgeben
						  //							1 = Fehlermeldung ausgeben 


/* Den analogen Eingang "nr" messen und das Ergebnis zurckgeben                 */
/* ==============================================================================*/
unsigned short FAR PASCAL ADC(short nr)
{
  return (Get_ADC(nr, linkaddr));   /* Messergebnis abholen */
}

/* Liefert die momentane Auslastung des Transputers                              */
/* ===================================================================MH=01=96===*/
short FAR PASCAL Auslast()
{
  return (AD_Auslastung(linkaddr));          /* Ergebnis abholen */
}

/* Abfragen der digitalen Eingnge. Die Eingnge stehen bitweise in einem 16-Bit Wort*/
/* =======================================================================MH=01=96===*/
long FAR PASCAL DigIn()
{
  return (Get_Digin(linkaddr));           /* Ergebnis abholen */
}

/* Rcklesen des auf den digitalen Ausgngen ausgegebenen Wertes                 */
/* ===================================================================MH=01=96===*/
long FAR PASCAL DigOut()
{
  return (Get_Digout(linkaddr));          /* Ergebnis abholen */
}

/* Liefert den momentanen freien Speicher des Transputers (Ergebnis in Bytes)    */
/* ===================================================================MH=01=96===*/
long FAR PASCAL Freemem()
{
  return (AD_Memory(linkaddr));          /* Ergebnis abholen */
}

/* Liefert den momentanen freien Speicher des ADSP (Ergebnis in Bytes)    */
/* ===================================================================MH=01=96===*/
long FAR PASCAL Freemem_T9(short typ)
{
  long mul=4;
  if (typ==1) mul=6;
  return (AD_Memory_all(typ, linkaddr)*mul);          /* Ergebnis abholen */
}

/* ADbasic ACTIVATE_PC-Flag abfragen und das Ergebnis zurckgeben                */
/* ==============================================================================*/
long FAR PASCAL GetActivate(short nr)
{
  short parno;
  long erg;

  parno = 930+nr-1000;
  erg = Get_ADBPar(parno, linkaddr);     /* Parameter holen */
  if (erg == 1) Set_ADBPar(parno, 0, linkaddr);
  return (erg);
}

/* Den analogen Ausgang "ndac" auf den Wert "iw" setzen                          */
/* ==============================================================================*/
short FAR PASCAL SetDAC (short ndac, unsigned short iw)
{
  return (Set_DAC(ndac, iw, linkaddr));
}

/* Gibt den Wert "iw" auf den digitalen Ausgngen aus                            */
/* ===================================================================MH=01=96===*/
short FAR PASCAL SetDigOut (short iw)
{
  return (Set_Digout(iw, linkaddr));
}

/* Einen Parameter auf der ADwin-Karte auf den Wert "il" setzen                  */
/* ==============================================================================*/
short FAR PASCAL SetPar (short npar, long il)
{
  return (Set_ADBPar(npar, il, linkaddr));
}

/* Eine Option auf der ADwin-Karte auf den Wert "il" setzen                  */
/* ==============================================================================*/
short FAR PASCAL SetOpt (short npar, long il)
{
  return (Set_ADBPar((short)(npar-1000), il, linkaddr));
}

/* Einen Float Parameter auf der ADwin-Karte auf den Wert "iw" setzen            */
/* ==============================================================================*/
short FAR PASCAL SetFPar (short npar, float iw)
{
  return (Set_ADBFPar(npar, iw, linkaddr));
}

/* Einen ADbasic Prozess auf der ADwin-Karte starten                             */
/* ==============================================================================*/
short FAR PASCAL ADBStart (short nproz)
{
  return (ADB_Start(nproz, linkaddr));
}

/* Einen zyklischen Prozess auf der ADwin-Karte starten                          */
/* ==============================================================================*/
short FAR PASCAL ZykStart (short nproz)
{
  return (Start(nproz, linkaddr));
}

/* Einen ADbasic Prozess auf der ADwin-Karte stoppen                             */
/* ==============================================================================*/
short FAR PASCAL ADBStop (short nproz)
{
  return (ADB_Stop(nproz, linkaddr));
}

/* Einen zyklischen Prozess auf der ADwin-Karte stoppen                          */
/* ==============================================================================*/
short FAR PASCAL ZykStop (short nproz)
{
  return (Stop(nproz, linkaddr));
}

/* Einen ADbasic short Parameter von der ADwin-Karte lesen                     */
/* ==============================================================================*/
long FAR PASCAL GetPar(short npar)
{
  return (Get_ADBPar(npar, linkaddr));            /* Parameter holen */
}

/* Eine Option von der ADwin-Karte lesen                                         */
/* ==============================================================================*/
long FAR PASCAL GetOpt(short npar)
{
  return (Get_ADBPar((short)(npar-1000), linkaddr));            /* Parameter holen */
}

/* Einen short Parameter von der ADwin-Karte lesen                             */
/* ==============================================================================*/
float FAR PASCAL GetFPar(short npar)
{
  return (Get_ADBFPar(npar, linkaddr));            /* Parameter holen */
}

/* Element/e aus einem ADbasic Datensatz vom Transputer holen.
            bergabe in short ARRAY*/
/* ==============================================================================*/
short FAR PASCAL GetData(short ndata, long nstart, long il, short iw[])
{
  return (Get_Data(iw, 1, ndata, nstart, il, linkaddr));
}

/* Element/e aus einem ADbasic Datensatz vom Transputer holen.
            bergabe in long ARRAY*/
/* ==============================================================================*/
short FAR PASCAL GetlData(short ndata, long nstart, long il, long iw[])
{
  return (Get_Data(iw, 2, ndata, nstart, il, linkaddr));
}

/* Element/e aus einem ADbasic Datensatz vom Transputer holen.
            bergabe in Float ARRAY*/
/* ==============================================================================*/
short FAR PASCAL GetfData(short ndata, long nstart, long il, float iw[])
{
  return (Get_Data(iw, 5, ndata, nstart, il, linkaddr));
}

/* Einem ADbasic Datensatz die Werte aus einem short ARRAY zuweisen*/
/* ==============================================================================*/
short FAR PASCAL SetData(short ndata, long start, long il, short iw[])
{
  return (Set_Data(iw, 1, ndata, start, il, linkaddr));
}

/* Das short Array auf welches iw zeigt als Ausgabesignalform auf ADwin-Karte ausgeben */
/* ==============================================================================*/
short FAR PASCAL SetDACListe (short ndac, long il, short iw[])
{
  return (Set_List(iw, 1, ndac, il, linkaddr));
}

/* Eine Messwertliste abfragen und in ein short Array schreiben                */
/* ==============================================================================*/
short FAR PASCAL ReadADListe(short nadc, long il, short iw[])
{
  return (Get_List(iw, 1, nadc, 1, il, linkaddr));
}

/* Einem ADbasic Datensatz die Werte aus einem long ARRAY zuweisen*/
/* ==============================================================================*/
short FAR PASCAL SetlData(short ndata, long start, long il, long iw[])
{
  return (Set_Data(iw, 2, ndata, start, il, linkaddr));
}

/* Einem ADbasic Datensatz die Werte aus einem Float ARRAY zuweisen*/
/* ==============================================================================*/
short FAR PASCAL SetfData(short ndata, long start, long il, float iw[])
{
  return (Set_Data(iw, 5, ndata, start, il, linkaddr));
}

/* Anzahl der Elemente im FIFO ermitteln                                         */
/* ==============================================================================*/
long FAR PASCAL GetFifoCount(short nfifo)
{
  return (Get_Fifo_Count(nfifo, linkaddr));
}

/* Anzahl der freien Positionen im FIFO ermitteln                                         */
/* ==============================================================================*/
long FAR PASCAL GetFifoEmpty(short nfifo)
{
  return (Get_Fifo_Empty(nfifo, linkaddr));
}

/* Inhalt des FIFO lschen                                                       */
/* ==============================================================================*/
short FAR PASCAL ClearFifo (short nfifo)
{
  return (Clear_Fifo(nfifo, linkaddr));
}

/* Element/e aus einem FIFO vom Transputer holen.
            bergabe in short ARRAY*/
/* ==============================================================================*/
short FAR PASCAL GetFifo(short nfifo, long il, short iw[])
{
  return (Get_Fifo(iw, 1, nfifo, il, linkaddr));
}

/* Element/e aus einem FIFO vom Transputer holen.
            bergabe in long ARRAY*/
/* ==============================================================================*/
short FAR PASCAL GetlFifo(short nfifo, long il, long iw[])
{
  return (Get_Fifo(iw, 2, nfifo, il, linkaddr));
}

/* Element/e aus einem FIFO vom Transputer holen.
            bergabe in Float ARRAY*/
/* ==============================================================================*/
short FAR PASCAL GetfFifo(short nfifo, long il, float iw[])
{
  return (Get_Fifo(iw, 5, nfifo, il, linkaddr));
}

/* Einem ADbasic FIFO die Werte aus einem short ARRAY zuweisen*/
/* ==============================================================================*/
short FAR PASCAL SetFifo(short nfifo, long il, short iw[])
{
  return (Set_Fifo(iw, 1, nfifo, il, linkaddr));
}

/* Einem ADbasic FIFO die Werte aus einem long ARRAY zuweisen*/
/* ==============================================================================*/
short FAR PASCAL SetlFifo(short nfifo, long il, long iw[])
{
  return (Set_Fifo(iw, 2, nfifo, il, linkaddr));
}

/* Einem ADbasic FIFO die Werte aus einem Float ARRAY zuweisen*/
/* ==============================================================================*/
short FAR PASCAL SetfFifo(short nfifo, long il, float iw[])
{
  return (Set_Fifo(iw, 5, nfifo, il, linkaddr));
}

/* Ld einen ADbasic Prozess auf die ADwin-Karte*/
/* ==============================================================================*/
short FAR PASCAL ADBPrLoad(char my_FAR *dateiname)
{
  return (ADBload(dateiname, linkaddr, message));                /* Laden */
}

/* Ld den Treiber der ADwin-Karte*/
/* ==============================================================================*/
long FAR PASCAL Iserv(char my_FAR *dateiname, long IboardSize)
{
  return (ADboot(dateiname, linkaddr, IboardSize, message));     /* ADwin Karte booten */
}

/* Ld den Treiber der ADwin-Karte*/
/* ==============================================================================*/
long FAR PASCAL Boot(char my_FAR *dateiname, long IboardSize)
{
  return (Iserv(dateiname, IboardSize));     /* ADwin Karte booten */
}

/* Testet, ob Transputer vorhanden und richtig initialisiert ist */
/* ==============================================================================*/
short FAR PASCAL Test()
{
  return (ADTest_Version(linkaddr, message));
}

/* Fehlermeldungen bei Iserv, ADPrLoad u. Test unterdrcken(state=0) o. zulassen(state=1) */
/* ==============================================================================*/
void FAR PASCAL ErrMessage(short state)
{
  message=state;
}

/* Baut ber Netzwerk eine Verbindung zu einem Rechner auf, an dem ein ADwin-System angeschlossen ist */
/* Auf dem Rechner mit dem ADwin-System mu das Programm ADserver.exe laufen, welches im Lieferumfang */
/* von ADbasic enthalten ist.                                                                         */ 
/* ===================================================================================================*/
short  FAR PASCAL Net_Connect(char my_FAR *prot, char my_FAR *addr, char my_FAR *EPoint, char my_FAR *PWord)
{
  return (AD_Net_Connect(prot, addr, EPoint, PWord, message));
}

/* Beendet die Verbindung die ber Net_Connect aufgebaut wurde                 */
/* ============================================================================*/
short  FAR PASCAL Net_Disconnect()
{
  return (AD_Net_Disconnect());
}


