unit Bas_dmo1;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, Uadwin, StdCtrls, ExtCtrls;

type
  TForm1 = class(TForm)
    Button1: TButton;
    Button2: TButton;
    Timer1: TTimer;
    Edit1: TEdit;
    Edit2: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    procedure Start_Click(Sender: TObject);
    procedure Stop_Click(Sender: TObject);
    procedure Timer1_Timer(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

var
  count: INTEGER;

const
  {btlfile     = 'C:ADWIN8.BTL';             {ADwin8-Karte Treiberprogramm}
   btlfile     = 'ADWIN4.BTL';               {ADwin4-Karte Treiberprogramm}
  {btlfile     = 'ADWIN2.BTL';               {ADwin2-Karte Treiberprogramm}
   size        = 100000;                     {ADwin-Karte Speichergre (1MB)}
  {size        = 400000;                     {ADwin-Karte Speichergre (4MB)}
  {size        = 800000;                     {ADwin-Karte Speichergre (8MB)}
   adbasicfile = 'BAS_DMO1.T41'; {ADwin-Karte ADbasic Prozess}

procedure TForm1.Start_Click(Sender: TObject);
begin
  start(1);                                  { ADbasic-Prozess1 starten }
  Timer1.Enabled := TRUE                     { Timer1 aktivieren        }
end;

procedure TForm1.Stop_Click(Sender: TObject);
begin
  Timer1.Enabled := FALSE;                    { Timer1 deaktivieren     }
  stop(1)                                     { ADbasic-Prozess1 stoppen}
end;

procedure TForm1.Timer1_Timer(Sender: TObject);
var par1, par2: LongInt;
begin
  IF get_activate(1) = 1 THEN BEGIN           {ACTIVATE_PC Flag gesetzt ?}
    par1 := get_par(1);                       {ADbasic Parameter1 holen  }
    par2 := get_par(2);                       {ADbasic Parameter2 holen  }
    Edit1.Text := IntToStr(par1);             {ADbasic Parameter1 anzeigen  }
    Edit2.Text := IntToStr(par2)              {ADbasic Parameter1 anzeigen  }
  END;
end;

initialization
  iserv(btlfile, size);   {Treiber auf ADwin-Karte laden}
  ADBload(adbasicfile);   {ADbasic Prozess auf ADwin-Karte laden}
end.



