unit Bas_dmo2;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, uadwin, StdCtrls;

type
  TForm1 = class(TForm)
    ScrollBar1: TScrollBar;
    ScrollBar2: TScrollBar;
    GroupBox1: TGroupBox;
    GroupBox2: TGroupBox;
    Edit1: TEdit;
    Edit2: TEdit;
    Button1: TButton;
    Button2: TButton;
    procedure Soll_Change(Sender: TObject);
    procedure Ver_Change(Sender: TObject);
    procedure Start_Click(Sender: TObject);
    procedure Stop_Click(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

const
  {btlfile     = 'ADWIN8.BTL';    {ADwin8-Karte Treiberprogramm}
   btlfile     = 'ADWIN4.BTL';    {ADwin4-Karte Treiberprogramm}
  {btlfile     = 'ADWIN2.BTL';    {ADwin2-Karte Treiberprogramm}
   size        = 100000;                  {ADwin-Karte Speichergre (1MB)}
  {size        = 400000;                  {ADwin-Karte Speichergre (4MB)}
  {size        = 800000;                  {ADwin-Karte Speichergre (8MB)}
   adbasicfile = 'BAS_DMO2.T41';  {ADwin-Karte ADbasic Prozess}

procedure TForm1.Soll_Change(Sender: TObject);
begin
  Edit1.Text:= IntToStr(ScrollBar1.Position);
  set_par(1, ScrollBar1.Position);                {ADbasic Parameter1 auf den
                                                   Wert des Scrollbalken setzen}
end;

procedure TForm1.Ver_Change(Sender: TObject);
begin
  Edit2.Text:= IntToStr(ScrollBar2.Position);
  set_par(2, ScrollBar2.Position);                {ADbasic Parameter2 auf den
                                                   Wert des Scrollbalken setzen}
end;

procedure TForm1.Start_Click(Sender: TObject);
begin
  ScrollBar1.Enabled:= TRUE;                {Sollwert Scrollbar aktivieren}
  ScrollBar2.Enabled:= TRUE;                {Verstrkung Scrollbar aktivieren}
  start(1);                               {ADbasic Prozess1 starten}
end;

procedure TForm1.Stop_Click(Sender: TObject);
begin
  stop(1);                                {ADbasic Prozess1 stoppen}
  ScrollBar1.Enabled:= FALSE;               {Sollwert Scrollbar deaktivieren}
  ScrollBar2.Enabled:= FALSE;               {Verstrkung Scrollbar deaktivieren}
end;

initialization
  iserv(btlfile, size);                {Treiber auf ADwin-Karte laden}
  ADBload(adbasicfile);                {ADbasic Prozess auf ADwin-Karte laden}

end.
