VERSION 4.00
Begin VB.Form Form1 
   Caption         =   " ADwin - BAS_DMO2"
   ClientHeight    =   3015
   ClientLeft      =   5115
   ClientTop       =   4890
   ClientWidth     =   6945
   Height          =   3420
   Icon            =   "bas_dmo_MAIN.frx":0000
   Left            =   5055
   LinkTopic       =   "Form1"
   ScaleHeight     =   3015
   ScaleWidth      =   6945
   Top             =   4545
   Width           =   7065
   Begin VB.Frame Frame2 
      Caption         =   "Gain"
      BeginProperty Font {0BE35203-8F91-11CE-9DE3-00AA004BB851} 
         Name            =   "MS Sans Serif"
         Size            =   12
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   1125
      Left            =   120
      TabIndex        =   5
      Top             =   1320
      Width           =   6615
      Begin VB.HScrollBar scroll_gain 
         Height          =   495
         LargeChange     =   5
         Left            =   240
         Max             =   100
         Min             =   1
         TabIndex        =   6
         Top             =   390
         Value           =   50
         Width           =   4695
      End
      Begin VB.Label gain 
         Alignment       =   2  'Center
         BackColor       =   &H0000FFFF&
         BorderStyle     =   1  'Fixed Single
         Caption         =   "50"
         BeginProperty Font {0BE35203-8F91-11CE-9DE3-00AA004BB851} 
            Name            =   "MS Sans Serif"
            Size            =   18
            Charset         =   0
            Weight          =   700
            Underline       =   0   'False
            Italic          =   0   'False
            Strikethrough   =   0   'False
         EndProperty
         ForeColor       =   &H000000FF&
         Height          =   465
         Left            =   5160
         TabIndex        =   8
         Top             =   390
         Width           =   1275
      End
   End
   Begin VB.Timer Timer1 
      Interval        =   100
      Left            =   6540
      Top             =   1050
   End
   Begin VB.CommandButton Quit 
      Caption         =   "Quit"
      Height          =   435
      Left            =   5640
      TabIndex        =   3
      Top             =   2550
      Width           =   1100
   End
   Begin VB.CommandButton Stopp 
      Caption         =   "Stop"
      Height          =   435
      Left            =   1500
      TabIndex        =   2
      Top             =   2520
      Width           =   1100
   End
   Begin VB.CommandButton Start 
      Caption         =   "Start"
      Height          =   435
      Left            =   180
      TabIndex        =   1
      Top             =   2520
      Width           =   1100
   End
   Begin VB.Frame Frame1 
      Caption         =   "Setpoint"
      BeginProperty Font {0BE35203-8F91-11CE-9DE3-00AA004BB851} 
         Name            =   "MS Sans Serif"
         Size            =   12
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   1125
      Left            =   120
      TabIndex        =   0
      Top             =   60
      Width           =   6615
      Begin VB.HScrollBar scroll_set 
         Height          =   495
         LargeChange     =   100
         Left            =   240
         Max             =   4095
         TabIndex        =   4
         Top             =   420
         Value           =   2048
         Width           =   4695
      End
      Begin VB.Label setpoint 
         Alignment       =   2  'Center
         BackColor       =   &H0000FFFF&
         BorderStyle     =   1  'Fixed Single
         Caption         =   "2000"
         BeginProperty Font {0BE35203-8F91-11CE-9DE3-00AA004BB851} 
            Name            =   "MS Sans Serif"
            Size            =   18
            Charset         =   0
            Weight          =   700
            Underline       =   0   'False
            Italic          =   0   'False
            Strikethrough   =   0   'False
         EndProperty
         ForeColor       =   &H000000FF&
         Height          =   465
         Left            =   5160
         TabIndex        =   7
         Top             =   420
         Width           =   1275
      End
   End
End
Attribute VB_Name = "Form1"
Attribute VB_Creatable = False
Attribute VB_Exposed = False
Rem  BAS_DMO2(c) Jger Messtechnik GmbH (proportional controller)
Rem 26.04.1999 OL
Rem Visual Basic 4.0 32 Bit
Rem ADwin-Gold 16 Bit (Default)

Option Explicit
Option Base 1
Const PAR_set  As Long = 1                     'number of steps in the signal array to achive the frequency
Const PAR_gain As Long = 2                     'amplitude
Const btlpath As String = "C:\adbasic3\"       'path for btl-file
'Const btlfile As String = "adwin4.btl"        'btl-file depends on ADwin-System
'Const btlfile As String = "adwin5.btl"
'Const btlfile As String = "adwin8.btl"
Const btlfile As String = "adwin9.btl"
'Const size As Long = 100000                   'size of memory depends on ADwin-System
Const size As Long = 400000
'Const size As Long  = 800000
'Const process As String = "BAS_DMO2.t41"      'Binary file depends on ADwin-System
'Const process As String = "BAS_DMO2.t51"
'Const process As String = "BAS_DMO2.t81"
Const process As String = "BAS_DMO2.t91"

'Const mult = 1                                ' 12 Bit aligned
Const mult = 16                                ' 16 Bit aligned








Private Sub Form_Load()
Dim value As Long
Dim directory As String
  value = Boot(btlpath & btlfile, size)        'Boot ADwin-System
  directory = App.Path
  If (Len(directory) > 3) Then directory = directory & "\"
  value = ADBload(directory & process)            'Load process
  Call scroll_set_Change
  Call scroll_gain_Change
End Sub


Private Sub Form_Unload(Cancel As Integer)
  Stop_Proz (1)                           'Stop process
End Sub





Private Sub Quit_Click()
  Unload Me                     'end program
End Sub

Private Sub scroll_gain_Change()         'If new gain is sellected
  Gain.Caption = scroll_gain.value
  Call set_par(PAR_gain, scroll_gain.value)
End Sub

Private Sub scroll_set_Change()            ' If new Setpoint is selected
Dim i As Long
  i = scroll_set.value
  i = i * mult
  setpoint.Caption = i
  Call set_par(PAR_set, i)
End Sub

Private Sub Start_Click()
  Start.Enabled = False
  Stopp.Enabled = True
  Call start_proz(1)                  'start process
End Sub


Private Sub Stopp_Click()
  Start.Enabled = True
  Stopp.Enabled = False
  Call Stop_Proz(1)                       'stop process
End Sub










