VERSION 4.00
Begin VB.Form BAS_DMO3 
   Appearance      =   0  'Flat
   AutoRedraw      =   -1  'True
   BackColor       =   &H80000005&
   Caption         =   "Measurement"
   ClientHeight    =   4350
   ClientLeft      =   2730
   ClientTop       =   3525
   ClientWidth     =   6345
   DrawMode        =   16  'Merge Pen
   BeginProperty Font {0BE35203-8F91-11CE-9DE3-00AA004BB851} 
      Name            =   "MS Sans Serif"
      Size            =   8.25
      Charset         =   0
      Weight          =   700
      Underline       =   0   'False
      Italic          =   0   'False
      Strikethrough   =   0   'False
   EndProperty
   ForeColor       =   &H80000008&
   Height          =   4755
   Left            =   2670
   LinkTopic       =   "Form1"
   ScaleHeight     =   4350
   ScaleWidth      =   6345
   Top             =   3180
   Width           =   6465
   Begin VB.CommandButton Command1 
      Caption         =   "Exit"
      BeginProperty Font {0BE35203-8F91-11CE-9DE3-00AA004BB851} 
         Name            =   "Arial"
         Size            =   12
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   495
      Left            =   5040
      TabIndex        =   1
      Top             =   3750
      Width           =   1185
   End
   Begin VB.CommandButton Start 
      Appearance      =   0  'Flat
      BackColor       =   &H00FF0000&
      Caption         =   "Start"
      BeginProperty Font {0BE35203-8F91-11CE-9DE3-00AA004BB851} 
         Name            =   "Arial"
         Size            =   12
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   495
      Left            =   3780
      TabIndex        =   0
      Top             =   3765
      Width           =   1155
   End
   Begin VB.Timer Timer1 
      Enabled         =   0   'False
      Interval        =   1000
      Left            =   1020
      Top             =   180
   End
   Begin MSChartLib.MSChart graph 
      DragMode        =   1  'Automatic
      Height          =   3585
      Left            =   120
      OleObjectBlob   =   "bas_dmo_main.frx":0000
      TabIndex        =   2
      Top             =   60
      Width           =   6195
   End
End
Attribute VB_Name = "BAS_DMO3"
Attribute VB_Creatable = False
Attribute VB_Exposed = False
Rem  proportional controller(c) Jger Messtechnik GmbH
Rem 26.04.1999 OL
Rem Visual Basic 4.0 32 Bit

Option Explicit
Option Base 1
Const btlpath As String = "C:\adbasic3\"       'path for btl-file
'Const btlfile As String = "adwin4.btl"        'btl-file depends on ADwin-System
'Const btlfile As String = "adwin5.btl"
'Const btlfile As String = "adwin8.btl"
Const btlfile As String = "adwin9.btl"
'Const size As Long = 100000                   'size of memory depends on ADwin-System
Const size As Long = 400000
'Const size As Long  = 800000
'Const process As String = "measurement.t41"          'Binary file depends on ADwin-System
'Const process As String = "measurement.t51"
'Const process As String = "measurement.t81"
Const process As String = "measurement.t91"
Dim values(1000) As Long
Private Sub Command1_Click()
  Unload Me                     'end program
End Sub


Private Sub Form_Load()
Dim value As Long
Dim lauf As Long
Dim directory As String
  value = iserver(btlpath & btlfile, size)        'Boot ADwin-System
  directory = App.Path
  If (Len(directory) > 3) Then directory = directory & "\"
  value = ADBload(directory & process)            'Load process
  For lauf = 1 To 1000
    Graph.Row = lauf
    Graph.RowLabel = CStr(lauf - 1)
  Next lauf
End Sub

Private Sub Start_Click()
  Call start_proz(1)          'start ADbasic process1
  Timer1.Enabled = True:      'activate timer1
End Sub

Private Sub Timer1_Timer()
Dim i As Long
  If (Activate(1) = 1) Then                 ' If the measuremend is finished
    Call get_data_long(1, 1, 1000, values())   ' get elements from the ADbasic data set1
    For i = 1 To 1000
      Graph.Row = i
      Graph.Data = values(i)              ' transfer measurement value to graph
    Next i
  End If
End Sub

